      character*80 index(1000), s(2)
      character*1 c1, c2, bs
      bs = char(92)
      n = 0
      open(unit=1,file='index.tmp',status='old')
      do 900 i = 1,1000
          read(1,1000,end=1) index(i)
1000      format(a)
          n = n + 1
900   continue
1     continue
      call sort(n,index,s)
      call strip(n,index,s)
      open(unit=2,file='index.tex',status='unknown')
      write(2,1000) bs//'input indexmacros.tex'
      write(2,1000) bs//'indexout'
      do 901 i = 1,n
          write(2,1001) bs,bs,index(i)(1:leng(index(i))),bs
1001      format(a,'hbox to ',a,'hsize{',a,a,'hfill}')
          if(i.lt.n) then
              call upcase(c1,index(i)(1:1))
              call upcase(c2,index(i+1)(1:1))
              if(c1.ne.c2) then
                  write(2,1000) bs//'vskip 12pt'
              end if
          end if
901   continue
      write(2,1000) bs//'par'//bs//'vfill'//bs//'end'
      stop
      end

      subroutine sort(n,a,s)
* Sort on upper case strings only up to "|" (just before page number)
      character*(*) a(n), s(2)
      character*80 t
      do 10 j = n-1,1,-1
          k = j
          do 20 i = j+1,n
              call upcase(t,a(i))
              s(1) = t(1:index(t,'|'))
              call upcase(t,a(j))
              s(2) = t(1:index(t,'|'))
              if(s(2).le.s(1)) goto 21
              k = i
20        continue
21        continue
          if(k.eq.j) goto 10
          s(1) = a(j)
          do 30 i = j+1,k
              a(i-1) = a(i)
30        continue
          a(k) = s(1)
10    continue
      return
      end

      function leng(s)
      character*(*) s
      do 900 leng = len(s),1,-1
          if(s(leng:leng).ne.' ') return
900   continue
      return
      end

      subroutine upcase(d,s)
      character*(*) d, s
      do 10 i = 1,min(len(d),len(s))
          if(s(i:i).ge.'a' .and. s(i:i).le.'z') then
              d(i:i) = char(ichar(s(i:i))-32)
          else
              d(i:i) = s(i:i)
          end if
10    continue
      return
      end

      subroutine strip(n,s,t)
* Replace string with "|" stripped out and duplicates merged
      character*(*) s(n),t
      character*10 blank, arg
      integer page(10)
      data blank /'          '/
      m = 0
      npage = 0
      do 10 i = 1,n
      npage = npage + 1
      k = index(s(i),'|')
      t = s(i)(1:k-1)
      l = leng(s(i)) - k
      arg = blank
      arg(10-l:) = s(i)(k+1:k+l)
      read(arg,1000) page(npage)
1000  format(i10)

***************** BEWARE OF THIS ONE *******************
* Decrement page by 1 because TEX writes the next page *
********************************************************
*      page(npage) = page(npage) - 1
********************************************************
* Decrement page by 1 because TEX writes the next page *
***************** BEWARE OF THIS ONE *******************

      if(i.eq.n) goto 5
      if(t.eq.s(i+1)(1:index(s(i+1),'|')-1)) goto 10
5     m = m + 1
      if(npage.eq.1) then
          write(s(m),1001) t(1:leng(t)),page(1)
1001      format(a,',',i4,',')
      else
          call isort(npage,page)
          write(s(m),1002) t(1:leng(t)),(page(k),k=1,npage)
1002      format(a,',',20(i4,','))
      end if
      t = s(m)
      s(m) = t(:leng(t)-1)
      s(m)(leng(t):leng(t)+1) = '.'      
      npage = 0
10    continue
      n = m
      return
      end

      subroutine isort(n,m)
      integer m(n)
      do 10 j = n-1,1,-1
      k = j
      do 20 i = j+1,n
      if(m(j).le.m(i)) goto 21
20    k = i
21    continue
      if(k.eq.j) goto 10
      itemp = m(j)
      do 30 i = j+1,k
30    m(i-1) = m(i)
      m(k) = itemp
10    continue
      return
      end
